Bug 1479073 - Review Request: tcl-tclnagios - Library to simplify writing Nagios plugins in Tcl
Review Request: tcl-tclnagios - Library to simplify writing Nagios plugins in...
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Robert-André Mauchin
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2017-08-07 17:46 EDT by Wart
Modified: 2017-08-15 12:08 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2017-08-15 10:36:05 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
zebob.m: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Wart 2017-08-07 17:46:12 EDT
Spec URL: https://wart.fedorapeople.org/tcl-tclnagios.spec
SRPM URL: https://wart.fedorapeople.org/tcl-tclnagios-1.3-1.fc24.src.rpm
Description: A set of library functions to make it easier to write Nagios plugins in Tcl.
Fedora Account System Username: wart
Comment 1 Wart 2017-08-08 13:32:35 EDT
Updated spec and src rpm to clean up a couple of rpmlint warnings:

Updated SPEC: https://wart.fedorapeople.org/tcl-tclnagios.spec
Updated SRPM: https://wart.fedorapeople.org/tcl-tclnagios-1.3-2.fc27.src.rpm

Build result in koji:  https://koji.fedoraproject.org/koji/taskinfo?taskID=21110224
Comment 3 Robert-André Mauchin 2017-08-09 09:36:09 EDT
Hello,

A few thing:

 - The Group: tag is not needed. See https://fedoraproject.org/wiki/Packaging:Guidelines#Tags_and_Sections
 
 - Similarly, no need for %clean, no need for rm -rf $RPM_BUILD_ROOT in %install

 - No need for %defattr(-,root,root,-) in %files either

 - I don't understand why you define:
%global commit0 1009914f0683f1c7fe9f94ed2cbe895008c5e6d1
%global gittag0 v1.3
%global shortcommit0 %(c=%{commit0}; echo ${c:0:7})

If you package the version 1.3, you don't need all this, just use %{version}:
https://github.com/gitwart/%{shortname}/archive/v%{version}/%{shortname}-%{version}.tar.gz

  - You can drop the 'tcl' in both BuildRequires and Requires as the others dependencies already depends on it.

 - The BR "tcl-devel" could be required with pkgconfig: pkgconfig(tcl)

 - "make install DESTDIR=$RPM_BUILD_ROOT" should be replaced with the %make_install macro which takes care of the buildroot

 - Thus, "BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)"  is not needed either.

 - You have a Rpmlint error:
tcl-tclnagios.noarch: E: explicit-lib-dependency tcllib

 You shouldn't require directly the dependency to tcllib, it's automatically handled by dnf.



Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated". 15 files have unknown license. Detailed
     output of licensecheck in /home/bob/packaging/review/tcl-tclnagios
     /review-tcl-tclnagios/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[!]: Each %files section contains %defattr if rpm < 4.4
     Note: %defattr present but not needed
[x]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[!]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: %clean present but not required
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: tcl-tclnagios-1.3-3.fc27.noarch.rpm
          tcl-tclnagios-1.3-3.fc27.src.rpm
tcl-tclnagios.noarch: E: explicit-lib-dependency tcllib
2 packages and 0 specfiles checked; 1 errors, 0 warnings.
Comment 4 Wart 2017-08-09 11:41:18 EDT
Many thanks for the review.  It's been a few years since I last submitted a package, and it seems there have been some tweaks in the guidelines since then.

(In reply to Robert-André Mauchin from comment #3)
> Hello,
> 
> A few thing:
> 
[...]
>  - I don't understand why you define:
> %global commit0 1009914f0683f1c7fe9f94ed2cbe895008c5e6d1
> %global gittag0 v1.3
> %global shortcommit0 %(c=%{commit0}; echo ${c:0:7})

It was unnecessary clutter from the git source guidelines.  I've removed these.

>   - You can drop the 'tcl' in both BuildRequires and Requires as the others
> dependencies already depends on it.
>  - The BR "tcl-devel" could be required with pkgconfig: pkgconfig(tcl)

Technically, this would work, but to be pedantic, the package doesn't actually use the pkgconfig file from tcl-devel to build, it uses tclConfig.sh.  I'd like to keep the BR as 'tcl-devel' to preserve that distinction.

>  - You have a Rpmlint error:
> tcl-tclnagios.noarch: E: explicit-lib-dependency tcllib
> 
>  You shouldn't require directly the dependency to tcllib, it's automatically
> handled by dnf.

In this case, it's not.  tcllib is a script library, not a shared library, so the automatic dependency generation doesn't find it (I verified this behavior in a scratch build).  rpmlint is just confused because of the string 'lib' in the name 'tcllib'.

All of the other issues noted have been fixed.

Here is the revised spec/srpm:

SPEC: https://wart.fedorapeople.org/tcl-tclnagios.spec
SRPM: https://wart.fedorapeople.org/tcl-tclnagios-1.3-4.fc27.src.rpm
Scratch build: https://koji.fedoraproject.org/koji/taskinfo?taskID=21128126
Comment 5 Robert-André Mauchin 2017-08-09 12:27:39 EDT
This is good for me, tcllib is indeed a tcl library, and everything else is good to go.

Package accepted.

Thanks for your work.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated". 15 files have unknown license. Detailed
     output of licensecheck in /home/bob/packaging/review/tcl-tclnagios
     /review-tcl-tclnagios/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: tcl-tclnagios-1.3-4.fc27.noarch.rpm
          tcl-tclnagios-1.3-4.fc27.src.rpm
tcl-tclnagios.noarch: E: explicit-lib-dependency tcllib
2 packages and 0 specfiles checked; 1 errors, 0 warnings.
Comment 6 Gwyn Ciesla 2017-08-11 12:56:36 EDT
(fedrepo-req-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/tcl-tclnagios
Comment 7 Gwyn Ciesla 2017-08-11 12:56:43 EDT
(fedrepo-req-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/tcl-tclnagios
Comment 8 Fedora Update System 2017-08-15 12:08:16 EDT
tcl-tclnagios-1.3-4.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2017-a3c6361bc6

Note You need to log in before you can comment on or make changes to this bug.